"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/index.react-server.ts
var index_react_server_exports = {};
__export(index_react_server_exports, {
  fetchOffsetPaginationFallbackData: () => fetchOffsetPaginationFallbackData,
  fetchOffsetPaginationHasMoreFallbackData: () => fetchOffsetPaginationHasMoreFallbackData,
  fetchQueryFallbackData: () => fetchQueryFallbackData
});
module.exports = __toCommonJS(index_react_server_exports);
var import_server_only = require("server-only");

// src/query/prefetch.ts
var import_postgrest_core4 = require("@supabase-cache-helpers/postgrest-core");

// src/lib/constants.ts
var KEY_PREFIX = "postgrest";
var KEY_SEPARATOR = "$";
var INFINITE_KEY_PREFIX = "page";

// src/lib/create-key-getter.ts
var import_postgrest_core = require("@supabase-cache-helpers/postgrest-core");

// src/lib/encode.ts
var encode = (parser, isInfinite) => {
  var _a;
  return [
    KEY_PREFIX,
    isInfinite ? INFINITE_KEY_PREFIX : "null",
    parser.schema,
    parser.table,
    parser.queryKey,
    (_a = parser.bodyKey) != null ? _a : "null",
    `count=${parser.count}`,
    `head=${parser.isHead}`,
    parser.orderByKey
  ].join(KEY_SEPARATOR);
};

// src/lib/middleware.ts
var import_postgrest_core2 = require("@supabase-cache-helpers/postgrest-core");

// src/lib/use-postgrest-filter-cache.ts
var import_postgrest_core3 = require("@supabase-cache-helpers/postgrest-core");
var import_swr = require("swr");

// src/lib/use-queries-for-table-loader.ts
var import_swr2 = require("swr");

// src/query/prefetch.ts
function fetchQueryFallbackData(query) {
  return __async(this, null, function* () {
    if (!(0, import_postgrest_core4.isPostgrestBuilder)(query)) {
      throw new Error("Query is not a PostgrestBuilder");
    }
    return [
      encode(new import_postgrest_core4.PostgrestParser(query), false),
      yield query.throwOnError()
    ];
  });
}
function fetchOffsetPaginationHasMoreFallbackData(query, pageSize) {
  return __async(this, null, function* () {
    return [
      encode(new import_postgrest_core4.PostgrestParser(query.range(0, pageSize)), true),
      [
        yield (0, import_postgrest_core4.offsetPaginationHasMoreFetcher)(query, {
          offset: 0,
          limit: pageSize,
          pageSize
        })
      ]
    ];
  });
}
var fetchOffsetPaginationFallbackData = (query, pageSize) => __async(void 0, null, function* () {
  return [
    encode(new import_postgrest_core4.PostgrestParser(query.range(0, pageSize)), true),
    [
      yield (0, import_postgrest_core4.offsetPaginationFetcher)(query, {
        offset: 0,
        limit: pageSize
      })
    ]
  ];
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  fetchOffsetPaginationFallbackData,
  fetchOffsetPaginationHasMoreFallbackData,
  fetchQueryFallbackData
});
//# sourceMappingURL=index.react-server.js.map